import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.StringTokenizer;


/**
 * ICPC - CTU Open Contest 2021
 * Sample Solution: Diamond
 * 
 * @author Martin Kacer
 */
public class DiamondMK {
	StringTokenizer st = new StringTokenizer("");
	BufferedReader input = new BufferedReader(new InputStreamReader(System.in));
	boolean hasNextToken() {
		try {
			while (!st.hasMoreTokens()) {
				String line = input.readLine();
				if (line == null) return false;
				st = new StringTokenizer(line);
			}
		} catch (IOException ex) { throw new RuntimeException(ex); }
		return true;
	}
	String nextToken() {
		return (!hasNextToken()) ? null : st.nextToken();
	}
	int nextInt() {
		return Integer.parseInt(nextToken());
	}
	public static void main(String[] args) {
		int res = new DiamondMK().run();
		System.out.println(res < 0 ? "Impossible" : res);
	}
	
	static final int MAX = 21, DL=0, DR=1, DO=2, DI=3;
	boolean[][][] edge = new boolean[4][MAX][360];
	int cr, ca, down, qb, qe, tr, ta;
	int[][][] was = new int[MAX][360][360];
	int[] qr = new int[MAX*360*360], qa = new int[MAX*360*360], qd = new int[MAX*360*360];
	
	boolean between(int a1, int a2) {
		a1 += down; a2 += down + 360;
		while (a1 > 360) a1 -= 360;
		while (a2 >= a1+360) a2 -= 360;
		int a = ca; if (a < a1) a += 360;
		return a1 <= a && a <= a2;
	}
	
	boolean fall() {
		if (between(135, 225) && edge[DI][cr][ca]) { --cr; return true; }
		if (between(315, 45) && edge[DO][cr][ca]) { ++cr; return true; }
		if (between(181, 359) && edge[DR][cr][ca]) { if (++ca > 359) ca = 0; return true; }
		if (between(1, 179) && edge[DL][cr][ca]) { if (--ca < 0) ca = 359; return true; }
		if (between(91, 269) && edge[DI][cr][ca]) { --cr; return true; }
		if (between(271, 89) && edge[DO][cr][ca]) { ++cr; return true; }
		return false;
	}
	
	int enqueue(int dist) {
		while (fall()) ;
		if (cr == tr && ca == ta) return dist;
		if (was[cr][ca][down] == 0) {
			was[cr][ca][down] = dist+1;
			qr[qe] = cr; qa[qe] = ca; qd[qe++] = down;
		}
		return -1;
	}
	
	int run() {
		int n = nextInt();
		for (int r = 0; r < n; ++r) {
			int k = nextInt();
			for (int i = 0; i < k; ++i) {
				int x = nextInt(), y = nextInt(); if (y < x) y += 360;
				for (int j = x; j < y; ++j)
					edge[DR][r][j%360] = edge[DL][r][(j+1)%360] = true;
			}
			k = nextInt();
			for (int i = 0; i < k; ++i) {
				int x = nextInt();
				edge[DO][r][x] = edge[DI][r+1][x] = true;
			}
		}
		cr = nextInt(); ca = nextInt(); tr = nextInt(); ta = nextInt();
		qb = 0; qe = 0; down = 180;
		int res = enqueue(0); if (res >= 0) return res;
		for (; qb < qe; ++qb) {
			cr = qr[qb]; ca = qa[qb]; down = qd[qb];
			int dist = was[cr][ca][down];
			if (++down > 359) down = 0;
			if ((res = enqueue(dist)) >= 0) return res;
			
			cr = qr[qb]; ca = qa[qb]; down = qd[qb];
			if (--down < 0) down = 359;
			if ((res = enqueue(dist)) >= 0) return res;
		}
		return -1;
	}
}
