#!/usr/bin/env python3

import queue
import math
from sys import stderr

ID = 0
FALL_THROUGH_DEG = 45 # go through tunnel if deg below is at most this value

points = []

def deb(s):
    print(s, file=stderr)

def debr(s):
    print(s, file=stderr, end='')

class Pt:
    def __init__(self, level, rot, ball):
        global ID
        self.id = ID
        ID += 1
        self.distance = -1
        self.fall_to = -2
        self.next = []
        self.level = level
        self.rot = rot
        self.ball = ball
        points.append(self)
    def __repr__(self):
        return str(self.id) \
                + ' lev:' + str(self.level)\
                + ' rot:' + str(self.rot)\
                + ' bal:' + str(self.ball)\
                + ' rel:' + str(m(self.ball+self.rot))\
                + ' ->'\
                + ' d:' + str(self.distance)\
                + ' f:' + str(self.fall_to)\
                + ' n:' + str(self.next)

# load levels and build the graph
levels = int(input())
g = []
for i in range(levels):
    #  g.append([[Pt()]*360]*360) # all possible states - LEVEL, ROTATION, BALL
    rres = []
    for j in range(360):
        res = []
        for k in range(360):
            res.append(Pt(i,j,k))
        rres.append(res)
    g.append(rres)


def m(val):
    return ((val%360)+360)%360

hole_strings = []
# load each level, build maze level-wise
for i in range(levels):
    line = list(map(int,input().split(' ')))
    arc_count = line[0]
    for j in range(arc_count):
        fr = line[1+2*j]
        to = line[1+2*j+1]
        if to < fr: to += 360
        for rotation in range(360):
            for k in range(fr, to):
                kk = m(k)
                ll = m(k+1)
                a = g[i][rotation][kk]
                b = g[i][rotation][ll]
                a_tot_ball = m(rotation + kk)
                b_tot_ball = m(rotation + ll)
                if a.fall_to < 0:
                    if a_tot_ball > 0 and a_tot_ball < 180:   a.fall_to = b.id
                    else:                                     a.fall_to = -1
                if b.fall_to < 0:
                    if b_tot_ball > 180 and b_tot_ball < 360: b.fall_to = a.id
                    else:                                     b.fall_to = -1
    hole_strings.append(input())
# build holes
for i,hole_str in enumerate(hole_strings):
    line = list(map(int,hole_str.split(' ')))
    hole_count = line[0]
    for j in range(hole_count):
        pos = line[1+j]
        for rotation in range(360):
            lower = g[i][rotation][pos]
            upper = g[i+1][rotation][pos]
            if upper.fall_to == -2: upper.fall_to = -1
            if lower.fall_to == -2: lower.fall_to = -1
            #
            fall_down_angle = m(rotation+pos+180)-180
            fall_down_threshold = FALL_THROUGH_DEG
            # nothing to fall to yet = end of a line
            if upper.fall_to == -1: fall_down_threshold = 90-1
            if abs(fall_down_angle) <= fall_down_threshold:
                #  print(upper, 'falls down to', lower, 'because', fall_down_angle, '<=', fall_down_threshold, file=stderr)
                upper.fall_to = lower.id
            #
            fall_up_angle = m(rotation+pos)-180
            fall_up_threshold = FALL_THROUGH_DEG
            if lower.fall_to == -1: fall_up_threshold = 90-1
            if abs(fall_up_angle) <= fall_up_threshold:
                # print(lower, 'falls up to', upper, 'because', fall_up_angle, '<=', fall_up_threshold, file=stderr)
                lower.fall_to = upper.id
for i in range(math.ceil(math.log(len(points)))):
    for a in points:
        if a.fall_to >= 0 and points[a.fall_to].fall_to >= 0:
            a.fall_to = points[a.fall_to].fall_to
for i in range(levels):
    for j in range(360):
        for k in range(360):
            a = g[i][j][k]
            if a.fall_to == -1:
                a.next = [g[i][m(j+1)][k].id,g[i][m(j+360-1)][k].id]
start_line = input()
end_line = input()
[start_lev,start_ball] = list(map(int, start_line.split(' ')))
[end_lev,end_ball] = list(map(int, end_line.split(' ')))

q = queue.Queue()
start = g[start_lev][0][start_ball]
start.distance = 0
q.put(start.id)

while not q.empty():
    original = el = points[q.get()]
    #  print(el.level, el.ball)
    while el.fall_to != -1:
        nxt = points[el.fall_to]
        if nxt.distance == -1:
            nxt.distance = el.distance
            el = nxt
        else:
            break
    for nid in el.next:
        nxt = points[nid]
        if nxt.distance == -1:
            nxt.distance = original.distance + 1
            q.put(nxt.id)

#  print(end_lev, end_ball)
#  print(g[end_lev][m(360-end_ball)][end_ball])
#  print(g[end_lev][m(360+180-end_ball)][end_ball])
res = 1<<30
for rotation in range(360):
    tot_pos = rotation + end_ball
    a = g[end_lev][rotation][end_ball]
    if a.fall_to == -1:
        if a.distance != -1: res = min(res,a.distance)

#  for i in points:
    #  if i.ball == 0:
        #  print(i)

if res == 1<<30:
    print('Impossible')
else:
    print(res)

#  3 139
#  0 295
